PickItemsDialog (gCube Pick Item Widget 1.1.1-SNAPSHOT API)
Date: 2016-06-30

org.gcube.portlets.widgets.pickitem.client.dialog

## Class PickItemsDialog

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.google.gwt.user.client.ui.Panel
      - - com.google.gwt.user.client.ui.SimplePanel
        - - com.google.gwt.user.client.ui.PopupPanel
          - - org.gcube.portlets.widgets.pickitem.client.dialog.PickItemsDialog

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.logical.shared.HasCloseHandlers<com.google.gwt.user.client.ui.PopupPanel>, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.EventPreview, com.google.gwt.user.client.ui.AcceptsOneWidget, com.google.gwt.user.client.ui.HasAnimation, com.google.gwt.user.client.ui.HasOneWidget, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.HasWidgets, com.google.gwt.user.client.ui.HasWidgets.ForIsWidget, com.google.gwt.user.client.ui.IsWidget, com.google.gwt.user.client.ui.SourcesPopupEvents, Iterable<com.google.gwt.user.client.ui.Widget>

      public class PickItemsDialog
      extends com.google.gwt.user.client.ui.PopupPanel

  Author:
    Massimiliano Assante, ISTI-CNR Use this widget to display a a dropdown user list you can attach to a textbox to make select portal users typing @ To get to know which user was selected listen for the `PickedItemEvent` on the `HandlerManager` instance you pass to this widget.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.PopupPanel

      `com.google.gwt.user.client.ui.PopupPanel.AnimationType, com.google.gwt.user.client.ui.PopupPanel.PositionCallback`

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

    - ### Nested classes/interfaces inherited from interface com.google.gwt.user.client.ui.HasWidgets

      `com.google.gwt.user.client.ui.HasWidgets.ForIsWidget`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ARROW_DOWN`
    `static int` | `ARROW_UP`
    `static int` | `DELETE`
    `static int` | `ENTER`
    `static int` | `ESCAPE`
    `static int` | `TAB`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PickItemsDialog(char triggerChar, ArrayList<ItemBean> beans, com.google.gwt.event.shared.HandlerManager eventBus, int widthInPixel)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `onKeyPress(int cursorPos, int keyCode, int x, int y, String currText)` called for each onKeyPress event from the user
    `void` | `onKeyUp(int keyCode)` called for each onKeyUp event from the user
    `void` | `select(int displayIndex)` select the user in the model and in the view
    `void` | `showSuggestions(String query)`
    `void` | `withPhoto()` use if you have want to show a photo for the item or not, remember to provide it in `ItemBean` instances
    `void` | `withTriggerCharIncluded()` use to include the trigger char in search if your suggestions start with the trigger char (e.g.

    - ### Methods inherited from class com.google.gwt.user.client.ui.PopupPanel

      `addAutoHidePartner, addCloseHandler, addPopupListener, center, getAnimationType, getContainerElement, getGlassElement, getGlassStyleName, getOffsetHeight, getOffsetWidth, getPopupLeft, getPopupTop, getStyleElement, getTitle, hide, hide, isAnimationEnabled, isAutoHideEnabled, isAutoHideOnHistoryEventsEnabled, isGlassEnabled, isModal, isPreviewingAllNativeEvents, isShowing, isVisible, onEventPreview, onKeyDownPreview, onKeyPressPreview, onKeyUpPreview, onPreviewNativeEvent, onUnload, removeAutoHidePartner, removePopupListener, setAnimationEnabled, setAnimationType, setAutoHideEnabled, setAutoHideOnHistoryEventsEnabled, setGlassEnabled, setGlassStyleName, setHeight, setModal, setPopupPosition, setPopupPositionAndShow, setPreviewingAllNativeEvents, setTitle, setVisible, setWidget, setWidth, show, showRelativeTo`

    - ### Methods inherited from class com.google.gwt.user.client.ui.SimplePanel

      `add, getWidget, iterator, remove, setWidget`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Panel

      `add, adopt, clear, doAttachChildren, doDetachChildren, orphan, remove`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, fireEvent, getHandlerCount, getLayoutData, getParent, isAttached, isOrWasAttached, onAttach, onBrowserEvent, onDetach, onLoad, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, addStyleName, ensureDebugId, ensureDebugId, ensureDebugId, getAbsoluteLeft, getAbsoluteTop, getElement, getStyleName, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Field Detail

    - #### ARROW_UP

          public static final int ARROW_UP

      See Also:
        Constant Field Values

    - #### ARROW_DOWN

          public static final int ARROW_DOWN

      See Also:
        Constant Field Values

    - #### DELETE

          public static final int DELETE

      See Also:
        Constant Field Values

    - #### ENTER

          public static final int ENTER

      See Also:
        Constant Field Values

    - #### ESCAPE

          public static final int ESCAPE

      See Also:
        Constant Field Values

    - #### TAB

          public static final int TAB

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PickItemsDialog

          public PickItemsDialog(char triggerChar,
                         ArrayList<ItemBean> beans,
                         com.google.gwt.event.shared.HandlerManager eventBus,
                         int widthInPixel)

      Parameters:
        `triggerChar` - the 'single char' used to trigger the items list show, e.g. '@', '#' ....
        `the` - list of user to pick
        `eventBus` - the event bus on where the widget will fire the selected user event
        `widthInPixel` - the desired width (grater than 199 pixel)
        `hasPhoto` - tell of you have want to show photo for the item or not
        `includeTriggerChar` - true if your suggestions start with the trigger char (e.g. #anHashTag triggered by #) false otherwise

  - ### Method Detail

    - #### withPhoto

          public void withPhoto()

      use if you have want to show a photo for the item or not, remember to provide it in `ItemBean` instances

    - #### withTriggerCharIncluded

          public void withTriggerCharIncluded()

      use to include the trigger char in search if your suggestions start with the trigger char (e.g. #anHashTag triggered by #)

    - #### onKeyPress

          public void onKeyPress(int cursorPos,
                        int keyCode,
                        int x,
                        int y,
                        String currText)

      called for each onKeyPress event from the user
      Parameters:
        `keyCode` - the event keycode
        `x` -
        `y` -
        `currText` -

    - #### onKeyUp

          public void onKeyUp(int keyCode)

      called for each onKeyUp event from the user
      Parameters:
        `keyCode` - the event keycode

    - #### showSuggestions

          public void showSuggestions(String query)

    - #### select

          public void select(int displayIndex)

      select the user in the model and in the view
      Parameters:
        `displayIndex` -

Copyright © 2016. All Rights Reserved.